# Remove tax withheld for an invoice

> For the complete machine-readable documentation index, see [llms.txt](https://apidocs.chargebee.com/llms.txt).


[Idempotency Supported](/docs/api/idempotency)

Removes a `[linked_taxes_withheld](/docs/api/invoices/invoice-object#linked_taxes_withheld)` record from the `invoice` specified. This operation is allowed only when all of the following conditions are true:

-   `[invoice.status](/docs/api/invoices/invoice-object#status)` is one of the following: `payment_due`, `not_paid`, or `posted`.
-   There are no `[adjustment_credit_notes](/docs/api/invoices/invoice-object#adjustment_credit_notes)` associated with the invoice.
-   There are no `[issued_credit_notes](/docs/api/invoices/invoice-object#issued_credit_notes)` associated with the invoice.

## Sample Request

#### cURL

```bash
curl  https://{site}.chargebee.com/api/v2/invoices/__demo_inv__4/remove_tax_withheld \
     -u {site_api_key}:\
     -d "tax_withheld[id]"="tax_wh___test__8assSSmwIEze1w"
```

#### .NET

```dotnet
using ChargeBee.Api;
using ChargeBee.Models;

ApiConfig.Configure("{site}","{site_api_key}");
EntityResult result = Invoice.RemoveTaxWithheld("__demo_inv__4")
		.TaxWithheldId("tax_wh___test__8assSSmwIEze1w")
		.Request();

Invoice invoice = result.Invoice;
```

#### Go

```go
package main
import (
    "fmt"
    "github.com/chargebee/chargebee-go/v3"
    invoiceAction "github.com/chargebee/chargebee-go/v3/actions/invoice"
    "github.com/chargebee/chargebee-go/v3/models/invoice"
)
func main() {
    chargebee.Configure("{site_api_key}","{site}");
    res,err := invoiceAction.RemoveTaxWithheld("__demo_inv__4", &invoice.RemoveTaxWithheldRequestParams{
        TaxWithheld : &invoice.RemoveTaxWithheldTaxWithheldParams{
            Id : "tax_wh___test__8assSSmwIEze1w",
        },
    }).Request()
    if err != nil {
        fmt.Println(err)
    } else {
        Invoice := res.Invoice
    }
}
```

#### Go

```go
package main

import (
  "fmt"
  "github.com/chargebee/chargebee-go/v4"
)

func main() {
  config := &chargebee.ClientConfig{
    SiteName: "{site}",
    ApiKey: "{site_api_key}",
  }    
  client := chargebee.NewClient(config)
  req := &chargebee.InvoiceRemoveTaxWithheldRequest{
    TaxWithheld : &chargebee.InvoiceRemoveTaxWithheldTaxWithheld{
        Id : "tax_wh___test__8assSSmwIEze1w",
    },
}
  res, err := client.Invoice.RemoveTaxWithheld("__demo_inv__4", req)
      if err != nil {
        fmt.Println(err)
    } else {
        Invoice := res.Invoice
    }
}
```

#### Java

```java
import com.chargebee.*;
import com.chargebee.ListResult;
import com.chargebee.models.*;
import com.chargebee.models.enums.*;
import java.io.IOException;

public class Sample {

    public static void main(String args[]) throws IOException, Exception {
        Environment.configure("{site}", "{site_api_key}");
        Result result = Invoice.removeTaxWithheld("__demo_inv__4")
            .taxWithheldId("tax_wh___test__8assSSmwIEze1w")
            .request();

        Invoice invoice = result.invoice();
    }
}
```

#### Java

```java
import com.chargebee.v4.client.ChargebeeClient;
import com.chargebee.v4.models.invoice.Invoice;
import com.chargebee.v4.models.invoice.params.InvoiceRemoveTaxWithheldParams;
import com.chargebee.v4.models.invoice.responses.InvoiceRemoveTaxWithheldResponse;

public class InvoiceRemoveTaxWithheld {

    public static void main(String[] args) {
        ChargebeeClient client = ChargebeeClient.builder()
            .apiKey("{site_api_key}")
            .siteName("{site}")
            .build();

        InvoiceRemoveTaxWithheldParams.TaxWithheldParams taxWithheldParams =
            InvoiceRemoveTaxWithheldParams.TaxWithheldParams.builder()
                .id("tax_wh___test__8assSSmwIEze1w")
                .build();

        InvoiceRemoveTaxWithheldParams params = InvoiceRemoveTaxWithheldParams.builder()
            .taxWithheld(taxWithheldParams)
            .build();

        InvoiceRemoveTaxWithheldResponse response = client
            .invoices()
            .removeTaxWithheld("__demo_inv__4", params);

        Invoice invoice = response.getInvoice();
    }
}
```

#### Node.js

```node
import Chargebee from "chargebee";

const chargebee = new Chargebee({
    site: "{site}",
    apiKey: "{site_api_key}",
});

try {
    const result = await chargebee.invoice.removeTaxWithheld("__demo_inv__4", {
        tax_withheld: {
            id: "tax_wh___test__8assSSmwIEze1w"
        }
    });

    console.log(result);
    const invoice = result.invoice;
} catch (err) {
    console.log(err);
}
```

#### PHP

```php
<?php

require __DIR__ . '/vendor/autoload.php';

use Chargebee\ChargebeeClient;

$chargebee = new ChargebeeClient(options: [
    "site" => "{site}",
    "apiKey" => "{site_api_key}",
]);
$result = $chargebee->invoice()->removeTaxWithheld("__demo_inv__4", [
    "tax_withheld" => [
        "id" => "tax_wh___test__8assSSmwIEze1w"
    ]
]);
$invoice = $result->invoice;
```

#### Python

```python
from chargebee import Chargebee

cb_client = Chargebee(api_key="{site_api_key}", site="{site}")
response = cb_client.Invoice.remove_tax_withheld("__demo_inv__4",
    cb_client.Invoice.RemoveTaxWithheldParams(
        tax_withheld=cb_client.Invoice.RemoveTaxWithheldTaxWithheldParams(
            id="tax_wh___test__8assSSmwIEze1w"
        )
    )
)
invoice = response.invoice
```

#### Ruby

```ruby
require 'chargebee'

ChargeBee.configure(:site => "{site}",
  :api_key => "{site_api_key}")

result = ChargeBee::Invoice.remove_tax_withheld("__demo_inv__4",{
  :tax_withheld => {
    :id => "tax_wh___test__8assSSmwIEze1w"
  }
})

invoice = result.invoice
```

## Sample Response

```json
{
  "invoice": {
    "adjustment_credit_notes": {},
    "amount_adjusted": 0,
    "amount_due": 1000,
    "amount_paid": 0,
    "amount_to_collect": 1000,
    "applied_credits": {},
    "base_currency_code": "USD",
    "billing_address": {
      "first_name": "Rachel",
      "last_name": "Green",
      "object": "billing_address",
      "validation_status": "not_validated"
    },
    "channel": "web",
    "credits_applied": 0,
    "currency_code": "USD",
    "customer_id": "__test__8aszjSmwIBcx2w",
    "date": 1635076738,
    "deleted": false,
    "due_date": 1635076738,
    "dunning_attempts": [
      {
        "attempt": 0,
        "created_at": 1635076739,
        "dunning_type": "auto_collect",
        "retry_engine": "chargebee",
        "transaction_id": "txn___test__8aszjSmwIER23z",
        "txn_amount": 1000,
        "txn_status": "failure"
      },
      {..}
    ],
    "dunning_status": "in_progress",
    "exchange_rate": 1,
    "first_invoice": false,
    "generated_at": 1635076738,
    "has_advance_charges": false,
    "id": "__demo_inv__4",
    "is_gifted": false,
    "issued_credit_notes": {},
    "line_items": [
      {
        "amount": 1000,
        "customer_id": "__test__8aszjSmwIBcx2w",
        "date_from": 1635076738,
        "date_to": 1635163138,
        "description": "Basic USD 2",
        "discount_amount": 0,
        "entity_id": "basic-USD2",
        "entity_type": "plan_item_price",
        "id": "li___test__8aszjSmwIEO63y",
        "is_taxed": false,
        "item_level_discount_amount": 0,
        "object": "line_item",
        "pricing_model": "per_unit",
        "quantity": 1,
        "subscription_id": "__test__8aszjSmwIBcx2w",
        "tax_amount": 0,
        "tax_exempt_reason": "tax_not_configured",
        "unit_amount": 1000
      },
      {..}
    ],
    "linked_orders": {},
    "linked_payments": [
      {
        "applied_amount": 1000,
        "applied_at": 1635076739,
        "txn_amount": 1000,
        "txn_date": 1635076739,
        "txn_id": "txn___test__8aszjSmwIER23z",
        "txn_status": "failure"
      },
      {..}
    ],
    "net_term_days": 0,
    "next_retry_at": 1635163139,
    "object": "invoice",
    "price_type": "tax_exclusive",
    "recurring": true,
    "resource_version": 1517479147665,
    "round_off_amount": 0,
    "status": "payment_due",
    "sub_total": 1000,
    "subscription_id": "__test__8aszjSmwIBcx2w",
    "tax": 0,
    "term_finalized": true,
    "total": 1000,
    "updated_at": 1517479147,
    "write_off_amount": 0
  }
}
```

## URL Format

**POST** https://[site].chargebee.com/api/v2/invoices/{invoice-id}/remove_tax_withheld

## Input Parameters

- `tax_withheld` (optional, string)
  Parameters for tax\_withheld
  - `id` (required, string, max chars=40)
    An auto-generated unique identifier for the tax withheld. The value starts with the prefix `tax_wh_`. For example, `tax_wh_16BdDXSlbu4uV1Ee6` .

## Returns

- `invoice` (Invoice object)
  Resource object representing invoice
